import re as re
import sys
import os
import stringer_lex as lex
import stringer_parser as parser
import stringer_object as object

lex = lex.StringerLex()
lex.build()
parser = parser.StringerParser(lex)
parser.build()

prog = object.Program({})

def replace(match):
    grp = match.groups()
    if grp[2] != None:
        level = int(grp[2])
    else:
        level = 1
    code = grp[0]
    
    return prog.find(code, level)

read_file = open(sys.argv[1], 'r')
for line in read_file:
    file = open(line.strip(), 'r')
    data = file.read()
    print "Parsing: %r" % (file.name)
    prog.add(parser.run(data))
    file.close()
read_file.close()
#print "*** PROGRAM ***\n%r\n*** END PROGRAM***\n" % prog

write_file = open(sys.argv[2], 'r')
for line in write_file:
    file_in  = open(line.strip(), 'r')
    (base_name, ext) = os.path.splitext(file_in.name)
    file_out = open(base_name + "_out" + ext, 'w')
    
    print "Reading from: %r, Writing to:%r" % (file_in.name, file_out.name)
    data = re.sub(r'([a-zA-Z_]*[a-zA-Z])(_([0-9]+))?', replace, file_in.read())
    file_out.write(data)
    file_out.close()
    file_in.close()
